package com.rxida.xilinedu.sys.common;

import java.io.Serializable;
import java.util.List;

public interface CrudDao<T> extends Serializable {
    int insert(T entity);

    int update(T entity);

    int delete(T entity);

    List<T> findList(T entity);

    T get(T entity);

    void batchInsert(List<T> list);

    void batchUpdate(List<T> list);

    void batchDelete(List<T> list);

}
