package com.rxida.xilinedu.sys.entity;

import org.apache.shiro.SecurityUtils;
import org.apache.shiro.subject.Subject;

import java.io.Serializable;
import java.util.Date;
import java.util.UUID;

public class BaseEntity implements Serializable {
    protected String id;
    protected User createBy;
    protected Date createDate;
    protected User updateBy;
    protected Date updateDate;

    public String getId() {
        return id;
    }

    public void setId(String id) {
        this.id = id;
    }

    public User getCreateBy() {
        return createBy;
    }

    public void setCreateBy(User createBy) {
        this.createBy = createBy;
    }

    public Date getCreateDate() {
        return createDate;
    }

    public void setCreateDate(Date createDate) {
        this.createDate = createDate;
    }

    public User getUpdateBy() {
        return updateBy;
    }

    public void setUpdateBy(User updateBy) {
        this.updateBy = updateBy;
    }

    public Date getUpdateDate() {
        return updateDate;
    }

    public void setUpdateDate(Date updateDate) {
        this.updateDate = updateDate;
    }

    public void preInsert() {
        this.id = UUID.randomUUID().toString();
        this.createDate = new Date();
        this.updateDate = this.createDate;
        final Subject subject = SecurityUtils.getSubject();
        User currentUser = (User) subject.getPrincipal();
        this.createBy = currentUser;
        this.updateBy = currentUser;
    }

    public void preUpdate() {
        this.updateDate = this.createDate;
        final Subject subject = SecurityUtils.getSubject();
        User currentUser = (User) subject.getPrincipal();
        this.updateBy = currentUser;
    }
}
