package com.rxida.xilinedu.sys.web;

import com.rxida.xilinedu.sys.common.JsonResult;
import com.rxida.xilinedu.sys.entity.User;
import org.apache.shiro.SecurityUtils;
import org.apache.shiro.authc.*;
import org.apache.shiro.subject.Subject;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

@RestController
@CrossOrigin
public class LoginController {
    //退出的时候是get请求，主要是用于退出
    //post登录
    @PostMapping(value = "/login")
    public JsonResult login(@RequestBody User user) {
        JsonResult result = new JsonResult();
        Map<String, String> resultData = new HashMap<>();
        result.setData(resultData);
        //添加用户认证信息
        Subject subject = SecurityUtils.getSubject();
        UsernamePasswordToken usernamePasswordToken = new UsernamePasswordToken(user.getUsername(), user.getPassword());
        try {
            subject.login(usernamePasswordToken);
            resultData.put("token", usernamePasswordToken.toString());
            result.setMsg("success!!!");
            result.setCode(JsonResult.SUCCESS);
        } catch (UnknownAccountException uae) {
            resultData.put("token", usernamePasswordToken.toString());
            result.setCode(JsonResult.ERROE);
            result.setMsg("用户不存在");
        } catch (IncorrectCredentialsException ice) {
            resultData.put("token", usernamePasswordToken.toString());
            result.setCode(JsonResult.ERROE);
            result.setMsg("密码错误");
        } catch (LockedAccountException lae) {
            resultData.put("token", usernamePasswordToken.toString());
            result.setCode(JsonResult.ERROE);
            result.setMsg("用户锁定");
        } catch (ExcessiveAttemptsException eae) {
            resultData.put("token", usernamePasswordToken.toString());
            result.setCode(JsonResult.ERROE);
            result.setMsg("不允许登录");
        } catch (AuthenticationException ae) {
            resultData.put("token", usernamePasswordToken.toString());
            result.setCode(JsonResult.ERROE);
            result.setMsg("账号或密码错误");
        }
        resultData.put("token", "admin");
        result.setMsg("success!!!");
        result.setCode(JsonResult.SUCCESS);
        return result;
    }

    @RequestMapping(value = "/index")
    public String index() {
        return "index";
    }

    //登出
    @PostMapping(value = "/logout")
    public JsonResult logout() {
        Subject subject = SecurityUtils.getSubject();
        subject.logout();
        JsonResult jsonResult = new JsonResult();
        jsonResult.setMsg("success!!!");
        jsonResult.setCode(JsonResult.SUCCESS);
        return jsonResult;
    }

    //错误页面展示
    @RequestMapping(value = "/error", method = RequestMethod.POST)
    public String error() {
        return "error ok!";
    }

    /**
     * 是否是验证码登录
     *
     * @param useruame 用户名
     * @param isFail   计数加1
     * @param clean    计数清零
     * @return
     */
    @SuppressWarnings("unchecked")
    public static boolean isValidateCodeLogin(String useruame, boolean isFail, boolean clean) {
        return false;
        /*Map<String, Integer> loginFailMap = (Map<String, Integer>)CacheUtils.get("loginFailMap");
        if (loginFailMap==null){
            loginFailMap = new HashMap<>();
            CacheUtils.put("loginFailMap", loginFailMap);
        }
        Integer loginFailNum = loginFailMap.get(useruame);
        if (loginFailNum==null){
            loginFailNum = 0;
        }
        if (isFail){
            loginFailNum++;
            loginFailMap.put(useruame, loginFailNum);
        }
        if (clean){
            loginFailMap.remove(useruame);
        }
        return loginFailNum >= 3;*/
    }

}
